/[gentoo-x86]/eclass/java-vm-2.eclass
Gentoo

Contents of /eclass/java-vm-2.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.15 - (show annotations) (download)
Fri Oct 20 03:52:24 2006 UTC (8 years, 10 months ago) by nichoj
Branch: MAIN
Changes since 1.14: +31 -5 lines
Updated the setting of the Java nsplugin so that it works nicely with the new multilib support in java-nsplugin.

1 # Copyright 1999-2004 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/eclass/java-vm-2.eclass,v 1.14 2006/10/15 16:18:01 nichoj Exp $
4
5 # -----------------------------------------------------------------------------
6 # @eclass-begin
7 # @eclass-shortdesc Java Virtual Machine eclass
8 # @eclass-maintainer java@gentoo.org
9 #
10 # This eclass provides functionality which assists with installing
11 # virtual machines, and ensures that they are recognized by java-config.
12 #
13 # -----------------------------------------------------------------------------
14
15 inherit eutils
16
17 DEPEND="
18 =dev-java/java-config-2.0*
19 >=sys-apps/portage-2.1"
20 RDEPEND="
21 =dev-java/java-config-2.0*
22 =dev-java/java-config-1.3*"
23
24 export WANT_JAVA_CONFIG=2
25
26 if [[ "${SLOT}" != "0" ]]; then
27 VMHANDLE=${PN}-${SLOT}
28 else
29 VMHANDLE=${PN}
30 fi
31
32 JAVA_VM_CONFIG_DIR="/usr/share/java-config-2/vm"
33 JAVA_VM_DIR="/usr/lib/jvm"
34
35 EXPORT_FUNCTIONS pkg_postinst pkg_prerm
36
37 java-vm-2_pkg_postinst() {
38 # Set the generation-2 system VM, if it isn't set
39 if [[ -z "$(java-config-2 -f)" ]]; then
40 java_set_default_vm_
41 fi
42
43 # support both variables for now
44 if [[ ${JAVA_SUPPORTS_GENERATION_1} == 'true' && ${JAVA_VM_NO_GENERATION1} != 'true' ]]; then
45 local systemvm1="$(java-config-1 -f 2>/dev/null)"
46 # no generation-1 system-vm was previously set
47 if [[ -z "${systemvm1}" ]]; then
48 # if 20java exists, must be using old VM
49 if [[ -f /etc/env.d/20java ]]; then
50 ewarn "The current generation-1 system-vm is using an out-of-date VM,"
51 ewarn "as in, it hasn't been updated for use with the new Java sytem."
52 # othewise, it must not have been set before
53 else
54 ewarn "No generation-1 system-vm previously set."
55 fi
56 ewarn "Setting generation-1 system-vm to ${VMHANDLE}"
57 java-config-1 --set-system-vm=${P} 2>/dev/null
58 # dirty check to see if we are upgrading current generation-1 system vm
59 elif [[ "${systemvm1}" = ${VMHANDLE}* ]]; then
60 einfo "Emerging the current generation-1 system-vm..."
61 einfo "Updating its config files."
62 java-config-1 --set-system-vm=${P} 2>/dev/null
63 # dirty check to see if current system vm is a jre - replace it with
64 elif [[ "${systemvm1}" = *jre* ]]; then
65 ewarn "Current generation-1 system-vm is a JRE"
66 ewarn "For the new and old Java systems to coexist,"
67 ewarn "the generation-1 system-vm must be a JDK."
68 ewarn "Setting generation-1 system-vm to ${VMHANDLE}"
69 java-config-1 --set-system-vm=${P} 2>/dev/null
70 fi
71 # else... some other VM is being updated, so we don't have to worry
72 else
73 einfo "JREs and 1.5+ JDKs are not supported for use with generation-1."
74 einfo "This is because generation-1 is only for use for building packages."
75 einfo "Only generation-2 should be used by end-users,"
76 einfo "where all JREs and JDKs will be available"
77 fi
78
79 echo
80
81 java-vm_check-nsplugin
82 java_mozilla_clean_
83 }
84
85 java-vm_check-nsplugin() {
86 local libdir
87 if [[ ${VMHANDLE} =~ emul-linux-x86 ]]; then
88 libdir=lib32
89 else
90 libdir=lib
91 fi
92 # Install a default nsplugin if we don't already have one
93 if has nsplugin ${IUSE} && use nsplugin; then
94 if [[ ! -f /usr/${libdir}/nsbrowser/plugins/javaplugin.so ]]; then
95 einfo "No system nsplugin currently set."
96 java-vm_set-nsplugin
97 else
98 einfo "System nsplugin is already set, not changing it."
99 fi
100 einfo "You can change nsplugin with eselect java-nsplugin."
101 fi
102 }
103
104 java-vm_set-nsplugin() {
105 local extra_args
106 if use amd64; then
107 if [[ ${VMHANDLE} =~ emul-linux-x86 ]]; then
108 extra_args="32bit"
109 else
110 extra_args="64bit"
111 fi
112 einfo "Setting ${extra_args} nsplugin to ${VMHANDLE}"
113 else
114 einfo "Setting nsplugin to ${VMHANDLE}..."
115 fi
116 eselect java-nsplugin set ${extra_args} ${VMHANDLE}
117 }
118
119 java-vm-2_pkg_prerm() {
120 if [[ "$(java-config -f 2>/dev/null)" == "${VMHANDLE}" ]]; then
121 ewarn "It appears you are removing your system-vm!"
122 ewarn "Please run java-config -L to list available VMs,"
123 ewarn "then use java-config -S to set a new system-vm!"
124 fi
125 }
126
127 java_set_default_vm_() {
128 java-config-2 --set-system-vm="${VMHANDLE}"
129
130 einfo " ${P} set as the default system-vm."
131 }
132
133 get_system_arch() {
134 local sarch
135 sarch=$(echo ${ARCH} | sed -e s/[i]*.86/i386/ -e s/x86_64/amd64/ -e s/sun4u/sparc/ -e s/sparc64/sparc/ -e s/arm.*/arm/ -e s/sa110/arm/)
136 if [ -z "${sarch}" ]; then
137 sarch=$(uname -m | sed -e s/[i]*.86/i386/ -e s/x86_64/amd64/ -e s/sun4u/sparc/ -e s/sparc64/sparc/ -e s/arm.*/arm/ -e s/sa110/arm/)
138 fi
139 echo ${sarch}
140 }
141
142 # TODO rename to something more evident, like install_env_file
143 set_java_env() {
144 local platform="$(get_system_arch)"
145 local env_file="${D}${JAVA_VM_CONFIG_DIR}/${VMHANDLE}"
146 local old_env_file="${D}/etc/env.d/java/20${P}"
147 local source_env_file="${FILESDIR}/${VMHANDLE}.env"
148
149 if [[ ! -f ${source_env_file} ]]; then
150 die "Unable to find the env file: ${source_env_file}"
151 fi
152
153 dodir ${JAVA_VM_CONFIG_DIR}
154 sed \
155 -e "s/@P@/${P}/g" \
156 -e "s/@PN@/${PN}/g" \
157 -e "s/@PV@/${PV}/g" \
158 -e "s/@PF@/${PF}/g" \
159 -e "s/@PLATFORM@/${platform}/g" \
160 -e "/^LDPATH=.*lib\\/\\\"/s|\"\\(.*\\)\"|\"\\1${platform}/:\\1${platform}/server/\"|" \
161 < ${source_env_file} \
162 > ${env_file} || die "sed failed"
163
164 echo "VMHANDLE=\"${VMHANDLE}\"" >> ${env_file}
165
166 # generation-1 compatibility
167 # respect both variables for now...
168 if [[ ${JAVA_SUPPORTS_GENERATION_1} == 'true' && ${JAVA_VM_NO_GENERATION1} != 'true' ]]; then
169 einfo "Enabling generation-1 compatibility..."
170 dodir /etc/env.d/java # generation-1 compatibility
171 # We need to strip some things out of the new style env,
172 # because these end up going in the env
173 sed -e 's/.*CLASSPATH.*//' \
174 -e 's/.*PROVIDES.*//' \
175 ${env_file} \
176 > ${old_env_file} || die "failed to create generation-1 env file"
177 else
178 ewarn "Disabling generation-1 compatibility..."
179 fi
180
181 [[ -n ${JAVA_PROVIDE} ]] && echo "PROVIDES=\"${JAVA_PROVIDE}\"" >> ${env_file}
182
183 local java_home=$(source ${env_file}; echo ${JAVA_HOME})
184 [[ -z ${java_home} ]] && die "No JAVA_HOME defined in ${env_file}"
185
186 # Make the symlink
187 dosym ${java_home} ${JAVA_VM_DIR}/${VMHANDLE} \
188 || die "Failed to make VM symlink at ${JAVA_VM_DIR}/${VMHANDLE}"
189 }
190
191
192 java_get_plugin_dir_() {
193 echo /usr/$(get_libdir)/nsbrowser/plugins
194 }
195
196 install_mozilla_plugin() {
197 local plugin=${1}
198
199 if [ ! -f "${D}/${plugin}" ] ; then
200 die "Cannot find mozilla plugin at ${D}/${plugin}"
201 fi
202
203 local plugin_dir=/usr/share/java-config-2/nsplugin
204 dodir ${plugin_dir}
205 dosym ${plugin} ${plugin_dir}/${VMHANDLE}-javaplugin.so
206 }
207
208 java_mozilla_clean_() {
209 # Because previously some ebuilds installed symlinks outside of pkg_install
210 # and are left behind, which forces you to manualy remove them to select the
211 # jdk/jre you want to use for java
212 local plugin_dir=$(java_get_plugin_dir_)
213 for file in ${plugin_dir}/javaplugin_*; do
214 rm -f ${file}
215 done
216 for file in ${plugin_dir}/libjavaplugin*; do
217 rm -f ${file}
218 done
219 }
220
221 # ------------------------------------------------------------------------------
222 # @eclass-end
223 # ------------------------------------------------------------------------------

  ViewVC Help
Powered by ViewVC 1.1.20